"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderOrHydrateComponent = renderOrHydrateComponent;
exports.renderOrHydrateForceLoadedComponents = renderOrHydrateForceLoadedComponents;
exports.renderOrHydrateAllComponents = renderOrHydrateAllComponents;
exports.hydrateStore = hydrateStore;
exports.hydrateForceLoadedStores = hydrateForceLoadedStores;
exports.hydrateAllStores = hydrateAllStores;
exports.unmountAll = unmountAll;
var ReactDOM = require("react-dom");
var context_1 = require("./context");
var createReactOutput_1 = require("./createReactOutput");
var isServerRenderResult_1 = require("./isServerRenderResult");
var reactHydrateOrRender_1 = require("./reactHydrateOrRender");
var reactApis_1 = require("./reactApis");
var turbolinksUtils_1 = require("./turbolinksUtils");
var REACT_ON_RAILS_STORE_ATTRIBUTE = 'data-js-react-on-rails-store';
function delegateToRenderer(componentObj, props, railsContext, domNodeId, trace) {
    var name = componentObj.name, component = componentObj.component, isRenderer = componentObj.isRenderer;
    if (isRenderer) {
        if (trace) {
            console.log("DELEGATING TO RENDERER ".concat(name, " for dom node with id: ").concat(domNodeId, " with props, railsContext:"), props, railsContext);
        }
        component(props, railsContext, domNodeId);
        return true;
    }
    return false;
}
var getDomId = function (domIdOrElement) { return typeof domIdOrElement === 'string' ? domIdOrElement : domIdOrElement.getAttribute('data-dom-id') || ''; };
var ComponentRenderer = /** @class */ (function () {
    function ComponentRenderer(domIdOrElement) {
        var _this = this;
        var domId = getDomId(domIdOrElement);
        this.domNodeId = domId;
        this.state = 'rendering';
        var el = typeof domIdOrElement === 'string' ? document.querySelector("[data-dom-id=".concat(domId, "]")) : domIdOrElement;
        if (!el)
            return;
        var storeDependencies = el.getAttribute('data-store-dependencies');
        var storeDependenciesArray = storeDependencies ? JSON.parse(storeDependencies) : [];
        var _a = (0, context_1.getContextAndRailsContext)(), context = _a.context, railsContext = _a.railsContext;
        if (!context || !railsContext)
            return;
        // Wait for all store dependencies to be loaded
        this.renderPromise = Promise.all(storeDependenciesArray.map(function (storeName) { return context.ReactOnRails.getOrWaitForStore(storeName); })).then(function () {
            if (_this.state === 'unmounted')
                return Promise.resolve();
            return _this.render(el, context, railsContext);
        });
    }
    /**
     * Used for client rendering by ReactOnRails. Either calls ReactDOM.hydrate, ReactDOM.render, or
     * delegates to a renderer registered by the user.
     */
    ComponentRenderer.prototype.render = function (el, context, railsContext) {
        return __awaiter(this, void 0, void 0, function () {
            var name, domNodeId, props, trace, domNode, componentObj, shouldHydrate, reactElementOrRouterResult, rootOrElement, e_1, error;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        name = el.getAttribute('data-component-name') || '';
                        domNodeId = this.domNodeId;
                        props = (el.textContent !== null) ? JSON.parse(el.textContent) : {};
                        trace = el.getAttribute('data-trace') === 'true';
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 4, , 5]);
                        domNode = document.getElementById(domNodeId);
                        if (!domNode) return [3 /*break*/, 3];
                        return [4 /*yield*/, context.ReactOnRails.getOrWaitForComponent(name)];
                    case 2:
                        componentObj = _b.sent();
                        if (this.state === 'unmounted') {
                            return [2 /*return*/];
                        }
                        if (delegateToRenderer(componentObj, props, railsContext, domNodeId, trace)) {
                            return [2 /*return*/];
                        }
                        shouldHydrate = !!(ReactDOM.hydrate || ReactDOM.hydrateRoot) && !!domNode.innerHTML;
                        reactElementOrRouterResult = (0, createReactOutput_1.default)({
                            componentObj: componentObj,
                            props: props,
                            domNodeId: domNodeId,
                            trace: trace,
                            railsContext: railsContext,
                            shouldHydrate: shouldHydrate,
                        });
                        if ((0, isServerRenderResult_1.isServerRenderHash)(reactElementOrRouterResult)) {
                            throw new Error("  You returned a server side type of react-router error: ".concat(JSON.stringify(reactElementOrRouterResult), "\n  You should return a React.Component always for the client side entry point."));
                        }
                        else {
                            rootOrElement = (0, reactHydrateOrRender_1.default)(domNode, reactElementOrRouterResult, shouldHydrate);
                            this.state = 'rendered';
                            if (reactApis_1.supportsRootApi) {
                                this.root = rootOrElement;
                            }
                        }
                        _b.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        e_1 = _b.sent();
                        error = e_1 instanceof Error ? e_1 : new Error((_a = e_1 === null || e_1 === void 0 ? void 0 : e_1.toString()) !== null && _a !== void 0 ? _a : 'Unknown error');
                        console.error(error.message);
                        error.message = "ReactOnRails encountered an error while rendering component: ".concat(name, ". See above error message.");
                        throw error;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    ComponentRenderer.prototype.unmount = function () {
        var _a;
        if (this.state === 'rendering') {
            this.state = 'unmounted';
            return;
        }
        this.state = 'unmounted';
        if (reactApis_1.supportsRootApi) {
            (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
            this.root = undefined;
        }
        else {
            var domNode = document.getElementById(this.domNodeId);
            if (!domNode) {
                return;
            }
            try {
                ReactDOM.unmountComponentAtNode(domNode);
            }
            catch (e) {
                var error = e instanceof Error ? e : new Error('Unknown error');
                console.info("Caught error calling unmountComponentAtNode: ".concat(error.message, " for domNode"), domNode, error);
            }
        }
    };
    ComponentRenderer.prototype.waitUntilRendered = function () {
        if (this.state === 'rendering') {
            return this.renderPromise;
        }
        return Promise.resolve();
    };
    return ComponentRenderer;
}());
var StoreRenderer = /** @class */ (function () {
    function StoreRenderer(storeDataElement) {
        this.state = 'hydrating';
        var _a = (0, context_1.getContextAndRailsContext)(), context = _a.context, railsContext = _a.railsContext;
        if (!context || !railsContext) {
            return;
        }
        var name = storeDataElement.getAttribute(REACT_ON_RAILS_STORE_ATTRIBUTE) || '';
        var props = (storeDataElement.textContent !== null) ? JSON.parse(storeDataElement.textContent) : {};
        this.hydratePromise = this.hydrate(context, railsContext, name, props);
    }
    StoreRenderer.prototype.hydrate = function (context, railsContext, name, props) {
        return __awaiter(this, void 0, void 0, function () {
            var storeGenerator, store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, context.ReactOnRails.getOrWaitForStoreGenerator(name)];
                    case 1:
                        storeGenerator = _a.sent();
                        if (this.state === 'unmounted') {
                            return [2 /*return*/];
                        }
                        store = storeGenerator(props, railsContext);
                        context.ReactOnRails.setStore(name, store);
                        this.state = 'hydrated';
                        return [2 /*return*/];
                }
            });
        });
    };
    StoreRenderer.prototype.waitUntilHydrated = function () {
        if (this.state === 'hydrating') {
            return this.hydratePromise;
        }
        return Promise.resolve();
    };
    StoreRenderer.prototype.unmount = function () {
        this.state = 'unmounted';
    };
    return StoreRenderer;
}());
var renderedRoots = new Map();
function renderOrHydrateComponent(domIdOrElement) {
    var domId = getDomId(domIdOrElement);
    (0, turbolinksUtils_1.debugTurbolinks)("renderOrHydrateComponent ".concat(domId));
    var root = renderedRoots.get(domId);
    if (!root) {
        root = new ComponentRenderer(domIdOrElement);
        renderedRoots.set(domId, root);
    }
    return root;
}
function renderOrHydrateForceLoadedComponents() {
    var els = document.querySelectorAll(".js-react-on-rails-component[data-force-load=\"true\"]");
    els.forEach(function (el) { return renderOrHydrateComponent(el); });
}
function renderOrHydrateAllComponents() {
    var els = document.querySelectorAll(".js-react-on-rails-component");
    els.forEach(function (el) { return renderOrHydrateComponent(el); });
}
function unmountAllComponents() {
    renderedRoots.forEach(function (root) { return root.unmount(); });
    renderedRoots.clear();
    (0, context_1.resetContextAndRailsContext)();
}
var storeRenderers = new Map();
function hydrateStore(storeNameOrElement) {
    return __awaiter(this, void 0, void 0, function () {
        var storeName, storeRenderer, storeDataElement;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    storeName = typeof storeNameOrElement === 'string' ? storeNameOrElement : storeNameOrElement.getAttribute(REACT_ON_RAILS_STORE_ATTRIBUTE) || '';
                    storeRenderer = storeRenderers.get(storeName);
                    if (!storeRenderer) {
                        storeDataElement = typeof storeNameOrElement === 'string' ? document.querySelector("[".concat(REACT_ON_RAILS_STORE_ATTRIBUTE, "=\"").concat(storeNameOrElement, "\"]")) : storeNameOrElement;
                        if (!storeDataElement) {
                            return [2 /*return*/];
                        }
                        storeRenderer = new StoreRenderer(storeDataElement);
                        storeRenderers.set(storeName, storeRenderer);
                    }
                    return [4 /*yield*/, storeRenderer.waitUntilHydrated()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function hydrateForceLoadedStores() {
    return __awaiter(this, void 0, void 0, function () {
        var els;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    els = document.querySelectorAll("[".concat(REACT_ON_RAILS_STORE_ATTRIBUTE, "][data-force-load=\"true\"]"));
                    return [4 /*yield*/, Promise.all(Array.from(els).map(function (el) { return hydrateStore(el); }))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function hydrateAllStores() {
    return __awaiter(this, void 0, void 0, function () {
        var els;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    els = document.querySelectorAll("[".concat(REACT_ON_RAILS_STORE_ATTRIBUTE, "]"));
                    return [4 /*yield*/, Promise.all(Array.from(els).map(function (el) { return hydrateStore(el); }))];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function unmountAllStores() {
    storeRenderers.forEach(function (storeRenderer) { return storeRenderer.unmount(); });
    storeRenderers.clear();
}
function unmountAll() {
    unmountAllComponents();
    unmountAllStores();
}
