import { RenderFunction } from './types';
export type RSCClientRootProps = {
    componentName: string;
    rscPayloadGenerationUrlPath: string;
    componentProps?: unknown;
};
/**
 * RSCClientRoot is a React component that handles client-side rendering of React Server Components (RSC).
 * It manages the fetching, caching, and rendering of RSC payloads from the server.
 *
 * This component:
 * 1. Fetches RSC payloads from the server using the provided URL path
 * 2. Caches the responses to prevent duplicate requests
 * 3. Transforms the response stream to replay server-side console logs
 * 4. Uses React.use() to handle the async data fetching
 *
 * @requires React 19+
 * @requires react-on-rails-rsc
 */
declare const RSCClientRoot: RenderFunction;
export default RSCClientRoot;
