"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
var server_node_1 = require("react-on-rails-rsc/server.node");
var stream_1 = require("stream");
var ReactOnRails_full_1 = require("./ReactOnRails.full");
var buildConsoleReplay_1 = require("./buildConsoleReplay");
var handleError_1 = require("./handleError");
var serverRenderUtils_1 = require("./serverRenderUtils");
var streamServerRenderedReactComponent_1 = require("./streamServerRenderedReactComponent");
var loadReactClientManifest_1 = require("./loadReactClientManifest");
var stringToStream = function (str) {
    var stream = new stream_1.PassThrough();
    stream.push(str);
    stream.push(null);
    return stream;
};
var streamRenderRSCComponent = function (reactElement, options) {
    var throwJsErrors = options.throwJsErrors, reactClientManifestFileName = options.reactClientManifestFileName;
    var renderState = {
        result: null,
        hasErrors: false,
        isShellReady: true
    };
    var _a = (0, streamServerRenderedReactComponent_1.transformRenderStreamChunksToResultObject)(renderState), pipeToTransform = _a.pipeToTransform, readableStream = _a.readableStream, emitError = _a.emitError;
    (0, loadReactClientManifest_1.default)(reactClientManifestFileName).then(function (reactClientManifest) {
        var rscStream = (0, server_node_1.renderToPipeableStream)(reactElement, reactClientManifest, {
            onError: function (err) {
                var error = (0, serverRenderUtils_1.convertToError)(err);
                console.error("Error in RSC stream", error);
                if (throwJsErrors) {
                    emitError(error);
                }
                renderState.hasErrors = true;
                renderState.error = error;
            }
        });
        pipeToTransform(rscStream);
    }).catch(function (e) {
        var error = (0, serverRenderUtils_1.convertToError)(e);
        renderState.hasErrors = true;
        renderState.error = error;
        var htmlResult = (0, handleError_1.default)({ e: error, name: options.name, serverSide: true });
        var jsonResult = JSON.stringify((0, serverRenderUtils_1.createResultObject)(htmlResult, (0, buildConsoleReplay_1.default)(), renderState));
        return stringToStream(jsonResult);
    });
    return readableStream;
};
ReactOnRails_full_1.default.serverRenderRSCReactComponent = function (options) {
    try {
        return (0, streamServerRenderedReactComponent_1.streamServerRenderedComponent)(options, streamRenderRSCComponent);
    }
    finally {
        console.history = [];
    }
};
__exportStar(require("./types"), exports);
exports.default = ReactOnRails_full_1.default;
