import type { ReactOnRails as ReactOnRailsType, RailsContext } from './types';
declare global {
    interface Window {
        ReactOnRails: ReactOnRailsType;
        __REACT_ON_RAILS_EVENT_HANDLERS_RAN_ONCE__?: boolean;
    }
    namespace globalThis {
        var ReactOnRails: ReactOnRailsType;
    }
}
export type Context = Window | typeof globalThis;
/**
 * Get the context, be it window or global
 */
export default function context(this: void): Context | void;
export declare function isWindow(ctx: Context): ctx is Window;
export declare function reactOnRailsContext(): Context;
export declare function getContextAndRailsContext(): {
    context: Context | null;
    railsContext: RailsContext | null;
};
export declare function resetContextAndRailsContext(): void;
