"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ReactDOMServer = require("react-dom/server");
var ComponentRegistry_1 = require("./ComponentRegistry");
var createReactOutput_1 = require("./createReactOutput");
var isServerRenderResult_1 = require("./isServerRenderResult");
var buildConsoleReplay_1 = require("./buildConsoleReplay");
var handleError_1 = require("./handleError");
var serverRenderUtils_1 = require("./serverRenderUtils");
function processServerRenderHash(result, options) {
    var redirectLocation = result.redirectLocation, routeError = result.routeError;
    var hasErrors = !!routeError;
    if (hasErrors) {
        console.error("React Router ERROR: ".concat(JSON.stringify(routeError)));
    }
    var htmlResult;
    if (redirectLocation) {
        if (options.trace) {
            var redirectPath = redirectLocation.pathname + redirectLocation.search;
            console.log("ROUTER REDIRECT: ".concat(options.componentName, " to dom node with id: ").concat(options.domNodeId, ", redirect to ").concat(redirectPath));
        }
        // For redirects on server rendering, we can't stop Rails from returning the same result.
        // Possibly, someday, we could have the Rails server redirect.
        htmlResult = '';
    }
    else {
        htmlResult = result.renderedHtml;
    }
    return { result: htmlResult, hasErrors: hasErrors };
}
function processPromise(result, renderingReturnsPromises) {
    if (!renderingReturnsPromises) {
        console.error('Your render function returned a Promise, which is only supported by a node renderer, not ExecJS.');
        // If the app is using server rendering with ExecJS, then the promise will not be awaited.
        // And when a promise is passed to JSON.stringify, it will be converted to '{}'.
        return '{}';
    }
    return result;
}
function processReactElement(result) {
    try {
        return ReactDOMServer.renderToString(result);
    }
    catch (error) {
        console.error("Invalid call to renderToString. Possibly you have a renderFunction, a function that already\ncalls renderToString, that takes one parameter. You need to add an extra unused parameter to identify this function\nas a renderFunction and not a simple React Function Component.");
        throw error;
    }
}
function processRenderingResult(result, options) {
    if ((0, isServerRenderResult_1.isServerRenderHash)(result)) {
        return processServerRenderHash(result, options);
    }
    if ((0, isServerRenderResult_1.isPromise)(result)) {
        return { result: processPromise(result, options.renderingReturnsPromises), hasErrors: false };
    }
    return { result: processReactElement(result), hasErrors: false };
}
function handleRenderingError(e, options) {
    if (options.throwJsErrors) {
        throw e;
    }
    var error = (0, serverRenderUtils_1.convertToError)(e);
    return {
        hasErrors: true,
        result: (0, handleError_1.default)({ e: error, name: options.componentName, serverSide: true }),
        error: error,
    };
}
function createPromiseResult(renderState, componentName, throwJsErrors) {
    return __awaiter(this, void 0, void 0, function () {
        var consoleHistory, html, consoleReplayScript, e_1, errorRenderState, consoleReplayScript;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    consoleHistory = console.history;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, renderState.result];
                case 2:
                    html = _a.sent();
                    consoleReplayScript = (0, buildConsoleReplay_1.default)(consoleHistory);
                    return [2 /*return*/, (0, serverRenderUtils_1.createResultObject)(html, consoleReplayScript, renderState)];
                case 3:
                    e_1 = _a.sent();
                    errorRenderState = handleRenderingError(e_1, { componentName: componentName, throwJsErrors: throwJsErrors });
                    consoleReplayScript = (0, buildConsoleReplay_1.default)(consoleHistory);
                    return [2 /*return*/, (0, serverRenderUtils_1.createResultObject)(errorRenderState.result, consoleReplayScript, renderState)];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function createFinalResult(renderState, componentName, throwJsErrors) {
    var result = renderState.result;
    if ((0, isServerRenderResult_1.isPromise)(result)) {
        return createPromiseResult(__assign(__assign({}, renderState), { result: result }), componentName, throwJsErrors);
    }
    var consoleReplayScript = (0, buildConsoleReplay_1.default)();
    return JSON.stringify((0, serverRenderUtils_1.createResultObject)(result, consoleReplayScript, renderState));
}
function serverRenderReactComponentInternal(options) {
    var componentName = options.name, domNodeId = options.domNodeId, trace = options.trace, props = options.props, railsContext = options.railsContext, renderingReturnsPromises = options.renderingReturnsPromises, throwJsErrors = options.throwJsErrors;
    var renderState = {
        result: null,
        hasErrors: false,
    };
    try {
        var componentObj = ComponentRegistry_1.default.get(componentName);
        (0, serverRenderUtils_1.validateComponent)(componentObj, componentName);
        // Renders the component or executes the render function
        // - If the registered component is a React element or component, it renders it
        // - If it's a render function, it executes the function and processes the result:
        //   - For React elements or components, it renders them
        //   - For promises, it returns them without awaiting (for async rendering)
        //   - For other values (e.g., strings), it returns them directly
        // Note: Only synchronous operations are performed at this stage
        var reactRenderingResult = (0, createReactOutput_1.default)({ componentObj: componentObj, domNodeId: domNodeId, trace: trace, props: props, railsContext: railsContext });
        // Processes the result from createReactOutput:
        // 1. Converts React elements to HTML strings
        // 2. Returns rendered HTML from serverRenderHash
        // 3. Handles promises for async rendering
        renderState = processRenderingResult(reactRenderingResult, { componentName: componentName, domNodeId: domNodeId, trace: trace, renderingReturnsPromises: renderingReturnsPromises });
    }
    catch (e) {
        renderState = handleRenderingError(e, { componentName: componentName, throwJsErrors: throwJsErrors });
    }
    // Finalize the rendering result and prepare it for server response
    // 1. Builds the consoleReplayScript for client-side console replay
    // 2. Extract the result from promise (if needed) by awaiting it
    // 3. Constructs a JSON object with the following properties:
    //    - html: string | null (The rendered component HTML)
    //    - consoleReplayScript: string (Script to replay console outputs on the client)
    //    - hasErrors: boolean (Indicates if any errors occurred during rendering)
    //    - renderingError: Error | null (The error object if an error occurred, null otherwise)
    // 4. For Promise results, it awaits resolution before creating the final JSON
    return createFinalResult(renderState, componentName, throwJsErrors);
}
var serverRenderReactComponent = function (options) {
    try {
        return serverRenderReactComponentInternal(options);
    }
    finally {
        // Reset console history after each render.
        // See `RubyEmbeddedJavaScript.console_polyfill` for initialization.
        // This is necessary when ExecJS and old versions of node renderer are used.
        // New versions of node renderer reset the console history automatically.
        console.history = [];
    }
};
exports.default = serverRenderReactComponent;
