import * as ReactDOMServer from 'react-dom/server';
import { Readable } from 'stream';
import type { ReactElement } from 'react';
import type { RenderParams, StreamRenderState } from './types';
export declare const transformRenderStreamChunksToResultObject: (renderState: StreamRenderState) => {
    readableStream: Readable;
    pipeToTransform: (pipeableStream: ReactDOMServer.PipeableStream) => void;
    writeChunk: (chunk: string) => boolean;
    emitError: (error: unknown) => void;
    endStream: () => void;
};
type StreamRenderer<T, P extends RenderParams> = (reactElement: ReactElement, options: P) => T;
export declare const streamServerRenderedComponent: <T, P extends RenderParams>(options: P, renderStrategy: StreamRenderer<T, P>) => T;
declare const streamServerRenderedReactComponent: (options: RenderParams) => Readable;
export default streamServerRenderedReactComponent;
