"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetch = void 0;
// Override the fetch function to make it easier to test
// The default fetch implementation in jest returns Node's Readable stream
// In jest.setup.js, we configure this fetch to return a web-standard ReadableStream instead,
// which matches browser behavior where fetch responses have ReadableStream bodies
// See jest.setup.js for the implementation details
var customFetch = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var res = fetch.apply(void 0, args);
    return res;
};
exports.fetch = customFetch;
